<?php
session_start();

$hostname = $_POST['hostname'];
$username = $_POST['username'];
$password = $_POST['password'];
$database = $_POST['database'];

try {
    $conn = new mysqli($hostname, $username, $password, $database);

    // Check for errors
    if ($conn->connect_error) {
        header("Location: ./?step=1&error=1");
        exit();
    }

    $config_content = "<?php\n";
    $config_content .= "\$db_host = '" . addslashes($hostname) . "';\n";
    $config_content .= "\$db_user = '" . addslashes($username) . "';\n";
    $config_content .= "\$db_pass = '" . addslashes($password) . "';\n";
    $config_content .= "\$db_name = '" . addslashes($database) . "';\n";
    $config_content .= "?>";

    $config_file = fopen("database.php", "w");
    fwrite($config_file, $config_content);
    fclose($config_file);

    $result = $conn->query("SHOW TABLES");
    if ($result->num_rows > 0) {
        while ($row = $result->fetch_row()) {
            $conn->query("DROP TABLE " . $row[0]);
        }
    }

    $sql_categories = "CREATE TABLE categories (
        category_id VARCHAR(100) PRIMARY KEY,
        category_name VARCHAR(50)
    )";

    $sql_checks = "CREATE TABLE checks (
        check_id VARCHAR(100) PRIMARY KEY,
        check_number VARCHAR(20),
        date_written DATE,
        payee_id VARCHAR(100),
        category_id VARCHAR(100),
        amount DECIMAL(12,2),
        memo_1 VARCHAR(100),
        memo_2 VARCHAR(100),
        times_printed INT(100),
        FOREIGN KEY (payee_id) REFERENCES payees(payee_id),
        FOREIGN KEY (category_id) REFERENCES categories(category_id)
    )";

    $sql_payees = "CREATE TABLE payees (
        payee_id VARCHAR(100) PRIMARY KEY,
        friendly_name VARCHAR(100),
        acct_number VARCHAR(20),
        categories VARCHAR(100),
        default_amt VARCHAR(15),
        default_memo VARCHAR(100)
    )";

    if ($conn->query($sql_categories) === TRUE &&
        $conn->query($sql_payees) === TRUE &&
        $conn->query($sql_checks) === TRUE) {
        header("Location: ./?step=2");
        exit();
    } else {
        echo "Error creating tables: " . $conn->error;
    }

    $conn->close();

} catch (mysqli_sql_exception $e) {
    header("Location: ./?step=1&error=1");
    exit();
}
?>